%global momorel 5
%global src_year 2006
%global src_month 05
%global src_day 17
%global src_date %{src_year}-%{src_month}-%{src_day}
%global rel 0.%{src_year}%{src_month}%{src_day}.%{momorel}

Summary: FFmpeg Streaming Multimedia System
Name: ffmpeg
Version: 0.4.9
%global src_name %{name}-%{version}
%global src_extract_name %{name}-%{version}-p%{src_year}%{src_month}%{src_day}

#Release: %{momorel}m
Release: %{rel}m
License: GPL
Group: Development/Libraries
# Since CVS server at mplayerhq.hu is now unreachable, we get cvs tarball from gentoo mirror
Source0: http://mirror.gentoo.gr.jp/distfiles/ffmpeg-0.4.9-p20060517.tar.bz2

Patch1: ffmpeg-0.4.9-20051207-a52link.patch
Patch2: ffmpeg-0.4.9-20051207-gsm.patch
Patch3: ffmpeg-0.4.9-20060517-enable-lzo.patch
URL: http://ffmpeg.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-root/
BuildPreReq: libvorbis-devel, a52dec-devel, faad2-devel, lame-devel
BuildPreReq: libtheora-devel, faac-devel, xvid
BuildPreReq: x264-devel >= 0.0.523-2m
BuildPreReq: zlib-devel >= 1.1.4-5m, SDL-devel, freetype2-devel, imlib2-devel
Requires: SDL >= 1.2.7-9m, libpostproc
%ifarch x86_64 ia64 ppc64 sparc64
Provides: libavcodec.so()(64bit)
Provides: libavformat.so()(64bit)
%else
Provides: libavcodec.so
Provides: libavformat.so
%endif

### include local configuration
%{?include_specopt}
# just a sample
# %%define extraconfopt --enable-mp3lame
# --enable-libgsm --enable-dts --enable-dv1394

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming
server and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it
into several file formats based on DCT/motion compensation
encoding. Sound is compressed in MPEG audio layer 2 or using an AC3
compatible stream.

%package devel
Summary: Header files and static library for the ffmpeg codec library
Group: Development/Libraries
Requires: %{name} = %{version}
Requires: imlib2-devel, SDL-devel, freetype2-devel, zlib-devel

%description devel
FFmpeg is a very fast video and audio converter. It can also grab from a
live audio/video source.
The command line interface is designed to be intuitive, in the sense that
ffmpeg tries to figure out all the parameters, when possible. You have
usually to give only the target bitrate you want. FFmpeg can also convert
from any sample rate to any other, and resize video on the fly with a high
quality polyphase filter.

Install this package if you want to compile apps with ffmpeg support.

%package -n libpostproc
Summary: Video postprocessing library from ffmpeg
Group: System Environment/Libraries
# We need to override version here... when libpostproc was built from
# MPlayer, it got up to 1.0-0.11.x) - mach barfs! :-(
#Version: 1.0.1
Provides: libpostproc-devel = %{version}-%{release}

%description -n libpostproc
FFmpeg is a very fast video and audio converter. It can also grab from a
live audio/video source.

This package contains only ffmpeg's libpostproc post-processing library which
other projects such as transcode may use. Install this package if you intend
to use MPlayer, transcode or other similar programs.


%prep
#'
%setup -q -n %{src_extract_name} 
%patch1 -p1 -b .a52link
%patch2 -p1 -b .gsm
%patch3 -p1 -b .lzo2

%build
find . -name "CVS" | xargs rm -rf
%ifarch x86_64
CFLAGS="%optflags" \
%else
CFLAGS="%optflags -fno-unit-at-a-time" \
%endif
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --mandir=%{_mandir} \
    --incdir=%{_includedir}/ffmpeg \
%if 1
    --extra-libs="-lX11" \
%endif
%ifarch x86_64
    --extra-cflags="-fPIC -DHAVE_LRINTF" \
%endif
    --enable-libogg --enable-vorbis \
    --enable-mp3lame \
    --enable-theora \
    --enable-faad \
    --enable-faac \
    --enable-xvid \
%if 1
    --enable-x264 \
%endif
    --enable-a52 --enable-a52bin \
    --enable-pp \
    --enable-shared \
    --enable-pthreads \
    --enable-gpl \
    --disable-opts \
    --disable-strip \
    %{?extraconfopt}

%{__make} %{?_smp_mflags}
# make -C doc
%{__make} documentation

%install
rm -rf %{buildroot}
%makeinstall \
    incdir=%{buildroot}%{_includedir}/ffmpeg

# Make installlib is broken in 0.4.6-8 (20050502 too), so we do it by hand
# in order to get the static libraries installed too.
%{__install} -m 0644 libav*/libav*.a %{buildroot}%{_libdir}/

# Remove unwanted files from the included docs
%{__cp} -a doc _docs
%{__rm} -rf _docs/{CVS,Makefile,*.1,*.texi,*.pl}

# The <postproc/postprocess.h> is now at <ffmpeg/postprocess.h>, so provide
# a compatibility copy
%{__mkdir_p} %{buildroot}%{_includedir}/postproc/
%{__cp} -a   %{buildroot}%{_includedir}/ffmpeg/postprocess.h \
             %{buildroot}%{_includedir}/postproc/postprocess.h

cd %{buildroot}%{_includedir}
ln -sf       postproc/postprocess.h postprocess.h
cd -

%clean
%{__rm} -rf %{buildroot}

%post
/sbin/ldconfig

%postun
if [ "$1" = 0 ]; then
    /sbin/ldconfig
fi

%post -n libpostproc
/sbin/ldconfig

%postun -n libpostproc
/sbin/ldconfig

%files
%defattr(-, root, root, 0755)
%doc Changelog COPYING CREDITS README
%{_bindir}/*
%{_libdir}/*.so.*
%exclude %{_libdir}/libpostproc.so*
%{_libdir}/vhook/
%{_mandir}/man1/*

%files devel
%defattr(-, root, root, 0755)
%doc doc/*
%{_includedir}/ffmpeg/
%{_libdir}/*.a
%{_libdir}/*.so
%exclude %{_libdir}/libpostproc.so
%{_libdir}/pkgconfig/*.pc
%exclude %{_libdir}/pkgconfig/libpostproc.pc

%files -n libpostproc
%defattr(-, root, root, 0755)
%{_includedir}/postprocess.h
%{_includedir}/postproc/
%{_libdir}/libpostproc.so*
%{_libdir}/pkgconfig/libpostproc.pc

%changelog
* Sun Jul 30 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.4.9-0.20060517.5m)
- remove ffmpeg-0.4.8-kernel2681.patch

* Tue May 30 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20060517.4m)
- %%exclude %%{_libdir}/libpostproc.so in devel (libpostproc owns it)

* Tue May 30 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.4.9-0.20060517.3m)
- added -DHAVE_LRINTF in --extra-cflags for x86_64 configure option
- added a link for postprocess.h in /usr/include

* Fri May 26 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20060517.2m)
- added --extra-libs="-lX11" to a configure option.
- - (a little mysterious... This is needed when compiling with x264-0.0.523-1m and this causes "undefined symbol" error at runtime. Then I removed this flag and it was built fine with x264-0.0.523-2m without "-lX11" the day before yesterday. But today, it can be build if and only if with "-lX11" today and ffmpeg works fine...what has changed??? )

* Wed May 24 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (0.4.9-0.20060517.1m)
- update to cvs snapshot 20060517
- - Since CVS server at mplayerhq.hu is unreachable now, we get cvs tarball from gentoo mirror :-P (http://mirror.gentoo.gr.jp/distfiles/)
- resync with freshrpms.net (ffmpeg-0.4.9-0.5.20060317.src.rpm)

* Sat Mar 11 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.20050208.6m)
- enable ppc.

* Sat Mar  4 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.20050208.5m)
- enable x86_64.

* Thu Nov  3 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (0.4.9-0.20050208.4m)
- add gcc4patch. import Gentoo patch.
- Patch20: ffmpeg-0.4.9-gcc4.patch

* Wed Oct 19 2005 Toru Hoshina <t@momonga-linux.org>
- (0.4.9-0.20050208.3m)
- enable ia64.
- libpostproc should be installed prior to the ffmpeg.
- avoid conflict with the libpostproc from the mplayer.

* Sat May 07 2005 Toru Hoshina <t@momonga-linux.org>
- (0.4.9-0.20050208.2m)
- enable x86_64. no more lib64 patch.

* Sat May 07 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.9-0.20050208.1m)
- update to cvs version
- * Sat Jan 15 2005 Dag Wieers <dag@wieers.com> - 0.4.9-0.20041110.3
- - Exclude libpostproc.so* from ffmpeg package.

* Fri Feb 18 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.8-7m)
- add lib64 patch.

* Tue Feb 16 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.4.8-6m)
- roll buck to 0.4.8

* Sat Feb 12 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (0.4.9-0.0.1.4m)
- rebuild against SDL-1.2.7-9m

* Fri Feb 11 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.0.1.3m)
- renew lib64 patch

* Wed Feb  9 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.9-0.0.1.2m)
- enable lame, faad, and a52 support

* Mon Feb  7 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.9-0.0.1.1m)
- update 0.4.9 pre1

* Mon Feb  7 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.8-5m)
- enable x86_64.

* Mon Oct 25 2004 Shigeyuki Yamashita <shige@momonga-linux.org>
- (0.4.8-4m)
- append CFLAGS fno-unit-at-a-time for compilation problems.

* Sat Aug 28 2004 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.4.8-3m)
- add Patch0: ffmpeg-0.4.8-kernel2681.patch

* Sat Apr 24 2004 Toru Hoshina <t@momomnga-linux.org>
- (0.1-7m)
- explicitly provides libavcodec.so and libavformat.so for anaconda.

* Thu Mar 18 2004 Toru Hoshina <t@momonga-linux.org>
- (0.4.8-2m)
- revised spec for enabling rpm 4.2.

* Wed Nov  5 2003 Masayuki SANO <sano@acs.i.kyoto-u.ac.jp>
- (0.4.8-1m)
- update to 0.4.8

* Tue Aug 26 2003 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.7-1m)

* Tue Apr 08 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.6-0.20021210.2m)
- rebuild against zlib 1.1.4-5m

* Wed Dec 11 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20021210.1m)

* Sun Nov 10 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20021110.1m)

* Sat Sep  7 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20020907.1m)
- initial import to Momonga
